//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  (c) 2010-present DEMOS plan GmbH.
//
//  This file is part of the package demosplan,
//  for more information see the license file.
//
//  All rights reserved
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//  Utility classes:
//      .width-<number|keyword|token-alias>(<unit>?)
//      .max-width-<number|keyword>(<unit>?)
//      .min-width-<token-alias>
//
// Units are only appended if they are not in px.
//
//  width: [<length>|<percentage>] && [border-box|content-box] ? |available|min-content|max-content|fit-content|auto
//  https://developer.mozilla.org/de/docs/Web/CSS/width

// Keyword based classes
.width-none {
    width: 0;
}

.width-auto {
    width: auto !important;
}

.max-width-none {
    max-width: none;
}

// Px-based classes like .width-160
$width-map-px: (
    'max-width': (350, 600),
    'min-width': (25),
    'width': (16, 20, 25, 40, 60, 85, 100, 120, 160, 200, 250, 300, 350, 450, 600)
);
@each $property, $widths in $width-map-px {
    @each $width in $widths {
        .#{$property}-#{$width} {
            #{$property}: #{$width}px;
        }
    }
}

// Percentage-based classes like .width-40p
$width-map-percentage: (
    'max-width': (90, 100),
    'width': (5, 10, 15, 20, 25, 40, 75, 100),
);
@each $property, $widths in $width-map-percentage {
    @each $width in $widths {
        .#{$property}-#{$width}p {
            #{$property}: #{$width}#{unquote('%')} !important;
        }
    }
}

// Classes that are directly bound to the spacing tokens
.min-width {
    &-m {
        min-width: $inuit-base-spacing-unit;
    }
}

.width {
    &-xs {
        width: $inuit-base-spacing-unit--tiny;
    }

    &-s {
        width: $inuit-base-spacing-unit--small;
    }

    &-m {
        width: $inuit-base-spacing-unit;
    }

    &-l {
        width: $inuit-base-spacing-unit--large;
    }

    &-xl {
        width: $inuit-base-spacing-unit--huge;
    }

    &-fit-content {
        width: fit-content;
    }

    &-max-content {
        width: max-content;
    }
}
